unit Unit2;
{$MAXSTACKSIZE $40001}
interface

uses
  Windows //fr GetAsyncKeyState
  //, Messages
  , SysUtils
  , Classes
  , Graphics
  , Controls
  , Forms
  , ExtCtrls
  , Dialogs
  //, tlhelp32
  ;

type
  TForm2 = class(TForm)
    Timer1: TTimer;
    procedure Neuzeichnen_ausloesen(Sender: TObject);
    procedure MausUnten_Forumular2_endet(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Tastendruck_Sortierungsabbruch_Formular2_endet(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure neuzeichnen;
  end;

  (*Neuzeichnenthread = class(TThread)
  private
    { Private-Deklarationen }
  protected
    procedure Execute; override;
    procedure array_neuzeichnen;
  end;*)

var
  Form2: TForm2;

implementation

uses Unit1;

{$R *.DFM}

procedure ereignis;
begin
if not pause then
  if sortierung_laeuft then abbruch:=true else
    begin
    //Form1.visible:=true;
    if Form2_Click_erlaubt and (Form1.CheckBox25.Checked or not Form1.visible or mischen_erlaubt)
    then mischen(true)
    else
    Form1.BringToFront;
    //SetForeGroundWindow(Form1.Handle);
    //BringWindowToTop(Form1.Handle)
    mischen_erlaubt:=false
    end
end;

procedure TForm2.Neuzeichnen;
var Bitmap:TBitmap;

  procedure Bresenham(P1,P2:TPoint);//https://www.delphipraxis.net/32071-linien-plotten-mit-bresenham.html

    //procedure TauschePunkte(var P1,P2:TPoint);var Temp:TPoint;begin Temp:=P1;P1:=P2;P2:=Temp end;

    {procedure plot(x,y:word);
    begin
    Bitmap.Canvas.Pen.Color:=Ausgabefarbe(y);
    Bitmap.Canvas.MoveTo(x,pred(Form1.SpinEdit3.Value));
    Bitmap.Canvas.LineTo(x,Form1.SpinEdit3.Value-succ(abs(Menge[y].key)));//abs wegen negativer Werte beim O-Sort
    endpos[y]:=succ(x)
    end;}

  var dy,e:integer;
  x,y,dx:word;
  begin
  //TauschePunkte(P1,P2);//hier nie erfllt, da beide 0
  e:=0;//Der relative Fehler (im Tutorial e' genannt)
  //x:=P1.X;//wird in der abgespeckten Algorithmusversion nie benutzt
  y:=P1.Y;
  dx:=P2.X-P1.X;
  dy:=P2.Y-P1.Y;
  if dy>=0 then//positive Steigung
    if dx>=dy
    then for x:=P1.X to P2.X do//leichte positive Steigung
      begin
      //Plot(x,y);
      Bitmap.Canvas.Pen.Color:=Ausgabefarbe(y);
      Bitmap.Canvas.MoveTo(x,pred(Form1.SpinEdit3.Value));
      Bitmap.Canvas.LineTo(x,Form1.SpinEdit3.Value-succ(abs(Menge[y].key)));//abs wegen negativer Werte beim O-Sort
      endpos[y]:=succ(x);
      if (e+dy) shl 1<dx
      then inc(e,dy)
      else
        begin
        inc(y);
        inc(e,dy-dx)
        end
      end
    {else for y:=P1.Y to P2.Y do//starke positive Steigung
      begin
      //Plot(x,y);
      Bitmap.Canvas.Pen.Color:=Ausgabefarbe(x);
      Bitmap.Canvas.MoveTo(y,pred(Form1.SpinEdit3.Value));
      Bitmap.Canvas.LineTo(y,Form1.SpinEdit3.Value-succ(abs(Menge[y].key)));//abs wegen negativer Werte beim O-Sort
      endpos[y]:=succ(x);
      if (e+dx) shl 1<dy
      then inc(e,dx)
      else
        begin
        inc(x);
        inc(e,dx-dy)
        end
      end}
  {else//negative Steigung
    if dx>=-dy
    then for x:=P1.X to P2.X do// leichte negative Steigung
      begin
      //Plot(x,y);
      if (e+dy) shl 1>-dx
      then inc(e,dy)
      else
        begin
        dec(y);
        inc(e,dy+dx)
        end
      end
    else//starke negative Steigung
      begin
      //TauschePunkte(P1,P2);
      x:=P1.X;
      dx:=P2.X-P1.X;
      dy:=P2.Y-P1.Y;
      for y:=P1.Y to P2.Y do
        begin
        //Plot(x,y);
        if (e+dx) shl 1>-dy
        then inc(e,dx)
        else
          begin
          dec(x);
          inc(e,dx+dy)
          end
        end
      end}
  end;

var P1,P2:TPoint;
//l:word;
//rect:TRect;
begin
//if not Form1.CheckBox28.Enabled then ClientWidth:=Form1.SpinEdit2.Value;//stattdessen in Prozedur mischen
Bitmap:=TBitmap.Create;
if Form1.RadioGroup1.ItemIndex=0 then Bitmap.Canvas.Brush.Color:=clWhite else Bitmap.Canvas.Brush.Color:=clBlack;
Bitmap.Height:=ClientHeight;
Bitmap.Width:=ClientWidth;
P1.x:=0;P1.y:=0;
P2.x:=pred(ClientWidth);
P2.y:=pred(Form1.SpinEdit2.Value);
Bresenham(P1,P2);
endpos[Form1.SpinEdit2.Value]:=Form2.Width;//statt immer in der Prozedur "linie_zeichnen" abzufragen

//rect.Bottom:=Form1.SpinEdit3.Value;
{for l:=0 to pred(Form1.SpinEdit2.Value) do
  begin
  //Variante mit Linien
  //Bitmap.Canvas.Pen.Color:=Ausgabefarbe(l);
  //Bitmap.Canvas.MoveTo(l,pred(Form1.SpinEdit3.Value));
  //Bitmap.Canvas.LineTo(l,Form1.SpinEdit3.Value-succ(abs(Menge[l].key)))//abs wegen negativer Werte beim O-Sort

  //Variante mit Rechtecken
  Bitmap.Canvas.Brush.Color:=Ausgabefarbe(l);
  rect.Left:=l;
  rect.Right:=succ(l);
  //rect.Bottom:=pred(Form1.SpinEdit3.Value);
  rect.Top:=rect.Bottom-abs(Menge[l].key);
  Bitmap.Canvas.FillRect(rect)
  end;}

Form2.canvas.Draw(0,0,bitmap);
Bitmap.Free;
SetWindowPos(Form1.Handle,{HWND_TOPMOST=-1 funktioniert nicht}HWND_TOP{=1 funktioniert}{HWND_BOTTOM=1 funktioniert nicht}{HWND_NOTOPMOST=-2 funktioniert},Form1.Left,Form1.Top,Form1.Width,Form1.Height,SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);//erfordert als einziger Befehl nicht das application.processmessages in Form1.verbergen, HWND_TOPMOST verhindert aber die kontextsensitive Hilfe
if Form1.Visible then Form1.SetFocus//Fokussieren erforderlich, damit Form1 auch zum Programmanfang den Fokus hat. Auf visible testen, weil es nicht immer visible ist und dann eine Fehlermeldung kommt.
//oder einer der folgenden Befehle, die allerdings application.processmessages in Form1.verbergen erfordern
//Form1.BringToFront
//SetForeGroundWindow(Form1.Handle);
//BringWindowToTop(Form1.Handle)
end;

procedure TForm2.Neuzeichnen_ausloesen(Sender: TObject);begin neuzeichnen end;

procedure TForm2.MausUnten_Forumular2_endet(Sender: TObject; Button: TMouseButton;
//Ereignis MouseDown kommt vor Ereignis MouseClick
  Shift: TShiftState; X, Y: Integer);
begin
ereignis
end;

procedure TForm2.Tastendruck_Sortierungsabbruch_Formular2_endet(Sender: TObject; var Key: Char);
begin
{Bei OnKeyDown wird auch z.B. die Alt-Taste bercksichtigt->keine Umschaltung
zwischen den Programmen mit Alt+Tab mglich, ohne die Sortierung zu beenden}
//if GetAsyncKeyState(27)<>0 then //nur Druck auf ESC-Taste fhrt zum Abbruch
if key='-' then
  if Form1.SpinEdit1.value=0
  then Form1.SpinEdit1.value:=1
  else Form1.SpinEdit1.value:=Form1.SpinEdit1.value shl 1
else if key='+' then Form1.SpinEdit1.value:=Form1.SpinEdit1.value shr 1
     else if (upcase(key)='V') then
            //begin
            //Vergleichsanzeiger:=not Vergleichsanzeiger;
            Form1.CheckBox15.Checked:=not Form1.CheckBox15.Checked
            //end
            else if (upcase(key)='B') then Form1.CheckBox24.Checked:=not Form1.CheckBox24.Checked
                 else if (upcase(key)='P') then
                        begin
                        neg(pause);
                        //Die nchsten beiden Zeilen verhindern die Anklickbarkeit von Form2, deshalb herausgenommen
                        //if screen.Cursor=crAppStart then screen.Cursor:=crHourGlass
                        //else if screen.Cursor=crHourGlass then screen.Cursor:=crAppStart
                        end
                      else ereignis
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
Width:=screen.width;
Height:=screen.height;
maximale_Spaltenanzahl_im_Fenster:=clientWidth;
maximale_Zeilenanzahl_im_Fenster:=clientHeight;
visible:=true;//show
mischen(true);
if Fileexists(IniFile.FileName) then
  begin
  left:=IniFile.ReadInteger('options','Form2.left',Form2.left);
  top:=IniFile.ReadInteger('options','Form2.top',Form2.top)
  end
else position:=poScreenCenter;
Caption:=Form1.Button2.Caption
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
abbruch:=true;
Form1.Close
end;

procedure TForm2.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if sortierung_laeuft and (screen.Cursor=crNone) then
  begin
  Timer1.Enabled:=false;//damit das Intervall von neuem zu laufen beginnt
  Timer1.Enabled:=true;
  if Form1.RadioGroup2.ItemIndex=0 then screen.Cursor:=crDefault
  end
end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
if sortierung_laeuft then
  begin
  GetCursorPos(CursorPos);
  if Form1.RadioGroup2.ItemIndex=0 then screen.Cursor:=crNone;
  Timer1.Enabled:=false
  end
end;

procedure TForm2.FormResize(Sender: TObject);
var v:boolean;
begin
if Form2_Click_erlaubt and (GetAsyncKeyState(VK_LBUTTON)<0) {and not sortierung_laeuft} then
  begin
  v:=clientHeight=Form1.SpinEdit3.Value;
  Form1.SpinEdit3.Value:=clientHeight;
  if Werteanzahl_mitlaufend or (Form1.SpinEdit7.Value>Form1.SpinEdit3.Value) then
    begin
    Form1.SpinEdit7.MaxValue:=Form1.SpinEdit3.MaxValue;
    Form1.SpinEdit7.Value:=Form1.SpinEdit3.Value
    end;
  if not (Form1.CheckBox28.Enabled and Form1.CheckBox28.Checked) or (ClientWidth<Form1.SpinEdit2.Value) then Form1.SpinEdit2.Value:=clientWidth;
  //vorher stand hiernach nur der Befehl "mischen", doch das Mischen ist nicht immer ntig
  if v and (ClientWidth>Form1.SpinEdit2.Value)
  then neuzeichnen//Refresh
  else mischen(false)
  end
end;

end.
