Unit Stackemulation;

interface

uses unit1;

type

link_word=^node_word;
node_word=record
  key,depth:word;
  next:link_word
  end;

link_pointer=^node_pointer;
node_pointer=record
  key:pointer;
  depth:word;
  next:link_pointer
  end;

link_Sortierelement=^node_sortierelement;
node_sortierelement=record
  key:TSortierelement;
  next:link_Sortierelement
  end;

//smtliche pushx- und popx-Befehle lieen sich auch mit push und pop berladen

TStackemulator=class
head,z:link_word;
constructor create(a:word);
destructor destroy;override;
procedure push(v:word);
function pop:word;
function gettop:word;
function getsubtop:word;
//function get_nth_top(n:word;save:boolean):word;
//procedure del_under_nth_top(n:word;save:boolean);
//procedure ins_under_nth_top(n,value:word;save:boolean);
//Werte von getdepth und getcount gleich; getdepth fragt depth ab, getcount zhlt per Schleife
function getdepth:word;
//function getcount:word;
//function getcount2:word;
//function getcount3:word;
function isempty(autodelete:boolean):boolean;
function isnotempty(autodelete:boolean):boolean;
//procedure deltop(x:word;save:boolean);
procedure leeren(autodelete:boolean);
//procedure pushn(a:array of word);
//procedure popn(out a:array of word);
procedure push2(a,b:word);
procedure pop2(out a,b:word);
procedure push3(a,b,c:word);
procedure pop3(out a,b,c:word);
procedure push4(a,b,c,d:word);
procedure pop4(out a,b,c,d:word);
procedure push5(a,b,c,d,e:word);
procedure pop5(out a,b,c,d,e:word);
procedure push6(a,b,c,d,e,f:word);
procedure pop6(out a,b,c,d,e,f:word);
procedure push7(a,b,c,d,e,f,g:word);
procedure pop8(out a,b,c,d,e,f,g,h:word);
procedure push8(a,b,c,d,e,f,g,h:word);
procedure pop7(out a,b,c,d,e,f,g:word);
procedure push9(a,b,c,d,e,f,g,h,i:word);
procedure pop9(out a,b,c,d,e,f,g,h,i:word);
//property stackleer:boolean read isempty;
//property size:word read getcount;
end;

PStackemulator=class
head,z:link_pointer;
constructor create(a:word);
destructor destroy;override;
procedure push(v:Pointer);
function pop:Pointer;
//function gettop:Pointer;
//function getsubtop:Pointer;
//function get_nth_top(n:word;save:boolean):Pointer;
//procedure del_under_nth_top(n:word;save:boolean);
//procedure ins_under_nth_top(n:word;value:Pointer;save:boolean);
//Werte von getdepth und getcount gleich; getdepth fragt depth ab, getcount zhlt per Schleife
//function getdepth:word;
//function getcount:word;
//function getcount2:word;
//function getcount3:word;
function isempty(autodelete:boolean):boolean;
//function isnotempty(autodelete:boolean):boolean;
//procedure deltop(x:word;save:boolean);
procedure leeren(autodelete:boolean);
procedure pushn(a:array of Pointer);
procedure popn(out a:array of Pointer);
procedure push2(a,b:Pointer);
procedure pop2(out a,b:Pointer);
//procedure push3(a,b,c:Pointer);
//procedure pop3(out a,b,c:Pointer);
//procedure push4(a,b,c,d:Pointer);
//procedure pop4(out a,b,c,d:Pointer);
//procedure push5(a,b,c,d,e:Pointer);
//procedure pop5(out a,b,c,d,e:Pointer);
//procedure push6(a,b,c,d,e,f:Pointer);
//procedure pop6(out a,b,c,d,e,f:Pointer);
//procedure push7(a,b,c,d,e,f,g:Pointer);
//procedure pop7(out a,b,c,d,e,f,g:Pointer);
//procedure push9(a,b,c,d,e,f,g,h,i:Pointer);
//procedure pop9(out a,b,c,d,e,f,g,h,i:Pointer);
//property stackleer:boolean read isempty;
//property size:word read getcount;
end;

TPile=class
head,z:link_Sortierelement;
constructor create(a:TSortierelement);overload;
constructor create;overload;
destructor destroy;override;
procedure push(v:TSortierelement);
function pop:TSortierelement;
function gettop:TSortierelement;
//function getsubtop:word;
//function getcount:word;
//function getcount2:word;
function isempty(autodelete:boolean):boolean;
//procedure deltop(x:word;save:boolean);
//procedure leeren(autodelete:boolean);
//procedure push2(a,b:word);
//procedure pop2(out a,b:word);
//procedure pop3(out a,b,c:word);
//procedure push3(a,b,c:word);
//procedure push4(a,b,c,d:word);
//procedure pop4(out a,b,c,d:word);
//procedure push5(a,b,c,d,e:word);
//procedure pop5(out a,b,c,d,e:word);
//procedure push6(a,b,c,d,e,f:word);
//procedure pop6(out a,b,c,d,e,f:word);
//procedure push7(a,b,c,d,e,f,g:word);
//procedure pop7(out a,b,c,d,e,f,g:word);
//procedure push9(a,b,c,d,e,f,g,h,i:word);
//procedure pop9(out a,b,c,d,e,f,g,h,i:word);
//property stackleer:boolean read isempty;
//property size:word read getcount;
end;

implementation

constructor TStackemulator.create(a:word);
var l:word;
begin
//inherited create;//?
new(head);
new(z);
head^.next:=z;
head^.next^.depth:=0;
//z^.next:=z;//?
for l:=1 to a do push(0)
end;

destructor TStackemulator.destroy;
begin
z^.next:=nil;
head^.next:=nil;
z:=nil;
head:=nil;
dispose(z);
dispose(head);
inherited
end;

procedure TStackemulator.push(v:word);
var t:link_word;
begin
new(t);
t^.key:=v;
t^.next:=head^.next;
t^.depth:=succ(head^.next^.depth);
head^.next:=t
end;

function TStackemulator.pop:word;
var t:link_word;
begin
//if head^.next<>z then//zur Sicherheit, aber bei sauberer Programmierung unntig
  //begin
  t:=head^.next;
  result:=t^.key;
  head^.next:=t^.next;
  dispose(t)
  //end
//else result:=0
end;

function TStackemulator.gettop:word;
begin
result:=head^.next^.key
end;

function TStackemulator.getsubtop:word;
begin
result:=head^.next^.next^.key
end;

{function TStackemulator.get_nth_top(n:word;save:boolean):word;
var l:word;
t:link_word;
begin
t:=head;
if save and (n<=getdepth) or not save then
  begin
  for l:=1 to n do t:=t^.next;
  result:=t^.key
  end
else result:=high(word)
end;

procedure TStackemulator.del_under_nth_top(n:word;save:boolean);
var temp:TStackemulator;x:word;
begin
if save and (n<getdepth) or not save then
  begin
  for x:=1 to n do temp.push(self.pop);
  self.pop;
  for x:=1 to n do self.push(temp.pop)
  end
end;

procedure TStackemulator.ins_under_nth_top(n,value:word;save:boolean);
var temp:TStackemulator;x:word;
begin
if save and (n<=getdepth) or not save then
  begin
  for x:=1 to n do temp.push(self.pop);
  self.push(value);
  for x:=1 to n do self.push(temp.pop)
  end
end;}

function TStackemulator.getdepth:word;begin result:=head^.next^.depth end;

{function TStackemulator.getcount:word;
var t:link_word;
begin
result:=0;
t:=head;
while t^.next<>z do
  begin
  t:=t^.next;
  inc(result)
  end
end;}

{function TStackemulator.getcount2:word;
var t:link_word;
begin
result:=0;
t:=head^.next;
while t<>z do
  begin
  inc(result);
  t:=t^.next
  end
end;

function TStackemulator.getcount3:word;
var temp:TStackemulator;
begin
temp:=TStackemulator.create(0);
result:=0;
while not self.isempty(false) do temp.push(self.pop);
while not temp.isempty(true) do
  begin
  inc(result);//oder schon in der ersten while-Schleife inkrementieren
  self.push(temp.pop)
  end
end;}

function TStackemulator.isempty(autodelete:boolean):boolean;
begin
result:=head^.next=z;//oder result:=head^.next^.depth=0;
if result and autodelete then destroy
end;

function TStackemulator.isnotempty(autodelete:boolean):boolean;
begin
result:=head^.next<>z;//oder result:=head^.next^.depth>0;
if not result and autodelete then destroy
end;


procedure TStackemulator.leeren(autodelete:boolean);
begin
while not isempty(autodelete) do pop
end;

{procedure TStackemulator.deltop(x:word;save:boolean);
var l:word;
begin
for l:=1 to x do if not save or save and not isempty(false) then pop
end;

procedure TStackemulator.pushn(a:array of word);
var l:byte;
begin
for l:=0 to high(a) do push(a[l])
end;

procedure TStackemulator.popn(out a:array of word);
var l:byte;
begin
for l:=high(a) downto 0 do a[l]:=pop
end;}

procedure TStackemulator.push2(a,b:word);
begin
push(a);
push(b)
end;

procedure TStackemulator.pop2(out a,b:word);
begin
b:=pop;
a:=pop
end;

procedure TStackemulator.push3(a,b,c:word);
begin
push2(a,b);
push(c)
end;

procedure TStackemulator.pop3(out a,b,c:word);
begin
pop2(b,c);
a:=pop
end;

procedure TStackemulator.push4(a,b,c,d:word);
begin
push2(a,b);
push2(c,d)
end;

procedure TStackemulator.pop4(out a,b,c,d:word);
begin
pop2(c,d);
pop2(a,b)
end;

procedure TStackemulator.push5(a,b,c,d,e:word);
begin
push3(a,b,c);
push2(d,e)
end;

procedure TStackemulator.pop5(out a,b,c,d,e:word);
begin
pop2(d,e);
pop3(a,b,c)
end;

procedure TStackemulator.push6(a,b,c,d,e,f:word);
begin
push3(a,b,c);
push3(d,e,f)
end;

procedure TStackemulator.pop6(out a,b,c,d,e,f:word);
begin
pop3(d,e,f);
pop3(a,b,c)
end;

procedure TStackemulator.push7(a,b,c,d,e,f,g:word);
begin
push3(a,b,c);
push4(d,e,f,g)
end;

procedure TStackemulator.pop7(out a,b,c,d,e,f,g:word);
begin
pop3(e,f,g);
pop4(a,b,c,d)
end;

procedure TStackemulator.push8(a,b,c,d,e,f,g,h:word);
begin
push4(a,b,c,d);
push4(e,f,g,h)
end;

procedure TStackemulator.pop8(out a,b,c,d,e,f,g,h:word);
begin
pop4(e,f,g,h);
pop4(a,b,c,d)
end;

procedure TStackemulator.push9(a,b,c,d,e,f,g,h,i:word);
begin
push3(a,b,c);
push3(d,e,f);
push3(g,h,i)
end;

procedure TStackemulator.pop9(out a,b,c,d,e,f,g,h,i:word);
begin
pop3(g,h,i);
pop3(d,e,f);
pop3(a,b,c)
end;

constructor PStackemulator.create(a:word);
var l:word;
begin
//inherited create;//?
new(head);
new(z);
head^.next:=z;
head^.next^.depth:=0;
//z^.next:=z;//?
for l:=1 to a do push(nil)
end;

destructor PStackemulator.destroy;
begin
z^.next:=nil;
head^.next:=nil;
z:=nil;
head:=nil;
dispose(z);
dispose(head);
inherited
end;

procedure PStackemulator.push(v:Pointer);
var t:link_pointer;
begin
new(t);
t^.key:=v;
t^.next:=head^.next;
t^.depth:=succ(head^.next^.depth);
head^.next:=t
end;

function PStackemulator.pop:Pointer;
var t:link_Pointer;
begin
//if head^.next<>z then//zur Sicherheit, aber bei sauberer Programmierung unntig
  //begin
  t:=head^.next;
  result:=t^.key;
  head^.next:=t^.next;
  dispose(t)
  //end
//else result:=nil
end;

{function PStackemulator.gettop:pointer;
begin
result:=head^.next^.key
end;

function PStackemulator.getsubtop:Pointer;
begin
result:=head^.next^.next^.key
end;

function PStackemulator.get_nth_top(n:word;save:boolean):Pointer;
var l:word;
t:link_Pointer;
begin
t:=head;
if save and (n<=getdepth) or not save then
  begin
  for l:=1 to n do t:=t^.next;
  result:=t^.key
  end
else result:=nil
end;

procedure PStackemulator.del_under_nth_top(n:word;save:boolean);
var temp:PStackemulator;x:word;
begin
if save and (n<getdepth) or not save then
  begin
  for x:=1 to n do temp.push(self.pop);
  self.pop;
  for x:=1 to n do self.push(temp.pop)
  end
end;

procedure PStackemulator.ins_under_nth_top(n:word;value:Pointer;save:boolean);
var temp:PStackemulator;x:word;
begin
if save and (n<=getdepth) or not save then
  begin
  for x:=1 to n do temp.push(self.pop);
  self.push(value);
  for x:=1 to n do self.push(temp.pop)
  end
end;

function PStackemulator.getdepth:word;begin result:=head^.next^.depth end;

function PStackemulator.getcount:word;
var t:link_Pointer;
begin
result:=0;
t:=head;
while t^.next<>z do
  begin
  t:=t^.next;
  inc(result)
  end
end;

function PStackemulator.getcount2:word;
var t:link_Pointer;
begin
result:=0;
t:=head^.next;
while t<>z do
  begin
  inc(result);
  t:=t^.next
  end
end;

function PStackemulator.getcount3:word;
var temp:PStackemulator;
begin
temp:=PStackemulator.create(0);
result:=0;
while not self.isempty(false) do temp.push(self.pop);
while not temp.isempty(true) do
  begin
  inc(result);//oder schon in der ersten while-Schleife inkrementieren
  self.push(temp.pop)
  end
end;}

function PStackemulator.isempty(autodelete:boolean):boolean;
begin
result:=head^.next=z;//oder result:=head^.next^.depth=0;
if result and autodelete then destroy
end;

{function PStackemulator.isnotempty(autodelete:boolean):boolean;
begin
result:=head^.next<>z;//oder result:=head^.next^.depth>0;
if not result and autodelete then destroy
end;}

procedure PStackemulator.leeren(autodelete:boolean);
begin
while not isempty(autodelete) do pop
end;

{procedure PStackemulator.deltop(x:word;save:boolean);
var l:word;
begin
for l:=1 to x do if not save or save and not isempty(false) then pop
end;}

procedure PStackemulator.pushn(a:array of Pointer);
var l:byte;
begin
for l:=0 to high(a) do push(a[l])
end;

procedure PStackemulator.popn(out a:array of Pointer);
var l:byte;
begin
for l:=high(a) downto 0 do a[l]:=pop
end;

procedure PStackemulator.push2(a,b:Pointer);
begin
push(a);
push(b)
end;

procedure PStackemulator.pop2(out a,b:Pointer);
begin
b:=pop;
a:=pop
end;

{procedure PStackemulator.push3(a,b,c:Pointer);
begin
push2(a,b);
push(c)
end;

procedure PStackemulator.pop3(out a,b,c:Pointer);
begin
pop2(b,c);
a:=pop
end;}

{procedure PStackemulator.push4(a,b,c,d:Pointer);
begin
push2(a,b);
push2(c,d)
end;

procedure PStackemulator.pop4(out a,b,c,d:Pointer);
begin
pop2(c,d);
pop2(a,b)
end;

procedure PStackemulator.push5(a,b,c,d,e:Pointer);
begin
push3(a,b,c);
push2(d,e)
end;

procedure PStackemulator.pop5(out a,b,c,d,e:Pointer);
begin
pop2(d,e);
pop3(a,b,c)
end;}

{procedure PStackemulator.push6(a,b,c,d,e,f:Pointer);
begin
//push3(a,b,c);
//push3(d,e,f)
push2(a,b);
push2(c,d);
push2(e,f)
end;

procedure PStackemulator.pop6(out a,b,c,d,e,f:Pointer);
begin
//pop3(d,e,f);
//pop3(a,b,c)
pop2(e,f);
pop2(c,d);
pop2(a,b)
end;}

(*procedure PStackemulator.push7(a,b,c,d,e,f,g:Pointer);
begin
{push3(a,b,c);
push4(d,e,f,g)}
{push2(a,b);
push2(c,d);
push2(e,f);
push(g)}
push(a);
push(b);
push(c);
push(d);
push(e);
push(f);
push(g)
end;

procedure PStackemulator.pop7(out a,b,c,d,e,f,g:Pointer);
begin
{pop3(e,f,g);
pop4(a,b,c,d)}
{pop2(f,g);
pop2(d,e);
pop2(b,c);
a:=pop}
g:=pop;
f:=pop;
e:=pop;
d:=pop;
c:=pop;
b:=pop;
a:=pop
end;*)

constructor TPile.create(a:TSortierelement);
begin
//inherited create;//?
new(head);
new(z);
head^.next:=z;
//z^.next:=z;//?
push(a)
end;

constructor TPile.create;
begin
//inherited create;//?
new(head);
new(z);
head^.next:=z
//z^.next:=z//?
end;

destructor TPile.destroy;
begin
z^.next:=nil;
head^.next:=nil;
z:=nil;
head:=nil;
dispose(z);
dispose(head);
inherited
end;

procedure TPile.push(v:TSortierelement);
var t:link_Sortierelement;
begin
new(t);
t^.key:=v;
t^.next:=head^.next;
head^.next:=t
end;

function TPile.pop:TSortierelement;
var t:link_sortierelement;
begin
//if head^.next<>z then//zur Sicherheit, aber bei sauberer Programmierung unntig
  begin
  t:=head^.next;
  result:=t^.key;
  head^.next:=t^.next;
  dispose(t)
  end
//else result:=0
end;

function TPile.gettop:TSortierelement;
begin
result:=head^.next^.key
end;

{function TPile.getcount:word;
var t:link_sortierelement;
begin
result:=0;
t:=head^.next;
while t<>z do
  begin
  inc(result);
  t:=t^.next
  end
end;}

function TPile.isempty(autodelete:boolean):boolean;
begin
result:=head^.next=z;
if result and autodelete then destroy
end;

{procedure TPile.leeren(autodelete:boolean);
begin
while not isempty(autodelete) do pop
end;}

end.